-- **************************************************************************
--   TitanClan.lua
--  
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanClan", true );

-- **************************************************************************
-- NAME : TitanClan_Init( state )
-- DESC : For first time addon use
-- **************************************************************************
function TitanClan_Init( state )
     if ( state == "checkDB" ) then
          checkDB = true;
          TitanClanInit = false;
     elseif ( state == "init" ) then
          checkDB = false;
     end
     if ( not TitanClan or TitanClan == nil ) then TitanClan = {}; end
     if ( not TitanClanInit or TitanClanInit == nil ) then
          if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 24, LB["TITAN_CLAN_MENU_CHECKDB"] ); end
	  if ( not TitanClanStaticArrays or TitanClanStaticArrays == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 26, LB["TITAN_CLAN_ARRAY"]:format( "TitanClanStaticArrays" ) ); end
               TitanClanStaticArrays = {};
          end
	  if ( not TitanClanLocals or TitanClanLocals == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 30, LB["TITAN_CLAN_ARRAY"]:format( "TitanClanLocals" ) ); end
               TitanClanLocals = {};
          end
	  if ( not TitanClanRoster or TitanClanRoster == nil ) then
               if ( checkDB ) then
                    TitanClan_CoreUtils( "buildRoster" );
                    TitanClan_DebugUtils( "Info", "TitanClan", 36, LB["TITAN_CLAN_ARRAY"]:format( "TitanClanRoster" ) );
               end
               TitanClanRoster = {};
          end
	  if ( not TitanClanRanks or TitanClanRanks == nil ) then
               if ( checkDB ) then
                    TitanClan_CoreUtils( "buildRanks" );
                    TitanClan_DebugUtils( "Info", "TitanClan", 36, LB["TITAN_CLAN_ARRAY"]:format( "TitanClanRanks" ) );
               end
               TitanClanRanks = {};
          end
	  if ( not TitanClanStaticArrays.presets or TitanClanStaticArrays.presets == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 38, LB["TITAN_CLAN_STATICARRAY_FIXED"]:format( "presets" ) ); end
               TitanClanStaticArrays.presets = {
                    LB["TITAN_CLAN_CONFIG_NONE"],
                    "!s (!l) !p ~ !z !c !r",
                    "!s (!l) !uc ~ !z !r",
               };
          end
	  if ( not TitanClanStaticArrays.sortTypes or TitanClanStaticArrays.sortTypes == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 49, LB["TITAN_CLAN_STATICARRAY_FIXED"]:format( "sortTypes" ) ); end
               TitanClanStaticArrays.sortTypes = {
                    -- This will need to localized
                    LB["TITAN_CLAN_CONFIG_NAME"], LB["TITAN_CLAN_CONFIG_ZONE"], LB["TITAN_CLAN_CONFIG_RANK"], LB["TITAN_CLAN_CONFIG_LEVEL"], LB["TITAN_CLAN_CONFIG_CLASS"],
               };
          end
	  if ( not TitanClanStaticArrays.Stream or TitanClanStaticArrays.Stream == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 56, LB["TITAN_CLAN_STATICARRAY_FIXED"]:format( "Stream" ) ); end
               TitanClanStaticArrays.Stream = {};
          end
	  if ( not TitanClanLocals.LocalClass or TitanClanLocals.LocalClass == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 60, LB["TITAN_CLAN_LOCALSARRAY_FIXED"]:format( "LocalClass" ) ); end
               TitanClanLocals.LocalClass = {};
          end
	  if ( not TitanClanLocals.ColorClass or TitanClanLocals.ColorClass == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 64, LB["TITAN_CLAN_LOCALSARRAY_FIXED"]:format( "ColorClass" ) ); end
               TitanClanLocals.ColorClass = {};
          end
	  if ( not TitanClanLocals.ToEnglish or TitanClanLocals.ToEnglish == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 68, LB["TITAN_CLAN_LOCALSARRAY_FIXED"]:format( "ToEnglish" ) ); end
               TitanClanLocals.ToEnglish = {};
          end
          if ( not TitanClanDebug or TitanClanDebug == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 72, LB["TITAN_CLAN_ARRAY"]:format( "TitanClanDebug" ) ); end
               TitanClanDebug = {
                    State = false,
                    Event = false,
                    LogEvent = false,
                    dLine = "",
                    FormatToRemove = LB["TITAN_CLAN_CONFIG_NONE"], 
                    Temp = {},
                    Log = {},
               };
          end
          if ( not TitanClan.Settings or TitanClan.Settings == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 84, LB["TITAN_CLAN_ARRAY_FIXED"]:format( "Settings" ) ); end
               TitanClan.Settings = {
                    ShowMem = true,
                    DisplayB = true,
                    tFormat = "!s (!l) !uc ~ !z !r",
                    sFormat = ( "<%s>" ):format( LB["TITAN_CLAN_CONFIG_AWAY"] ),
                    sType = LB["TITAN_CLAN_CONFIG_NAME"],
                    maxTooltip = 30,
                    Version = LB["TITAN_CLAN_CORE_VERSION"],
                    ArrayVersion = LB["TITAN_CLAN_CORE_AVER"],
               };
          end
          if ( not TitanClan.AddAuth or TitanClan.AddAuth == nil ) then
               if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 97, LB["TITAN_CLAN_ARRAY_FIXED"]:format( "AddAuth" ) ); end
               TitanClan.AddAuth = {};
          end
          TitanClanInit = true;
          if ( checkDB ) then TitanClan_DebugUtils( "Info", "TitanClan", 101, LB["TITAN_CLAN_MENU_CHECKDB_FINSIHED"] ); end
     end
     if ( not TitanClanProfile or TitanClanProfile == nil ) then
          TitanClanProfile = {};
     end
     TitanClanProfile = {
          Faction = LB["TITAN_CLAN_CONFIG_UNKNOWN"],
          Realm = LB["TITAN_CLAN_CONFIG_UNKNOWN"],
          Player = LB["TITAN_CLAN_CONFIG_UNKNOWN"],
     };
     if ( not TitanClanProfile.Locale or TitanClanProfile.Locale ~= GetLocale() ) then TitanClan_CoreUtils( "getLocals" ); end
     TitanClanDebug.FormatToRemove = LB["TITAN_CLAN_CONFIG_NONE"];
     if ( GetCVar( "guildMemberNotify" ) == "0" ) then TitanClan_GuildNotifyConcent(); end
     TitanClan_CoreUtils( "setUser" )
end

-- **************************************************************************
-- NAME : TitanPanelClanButton_OnEvent()
-- DESC : Event Handler
-- **************************************************************************
function TitanPanelClanButton_OnEvent( self, event, ... )
     local arg1 = ...
     if ( event == "ADDON_LOADED" and arg1 == "TitanClan" ) then
          TitanClan_Init( "init" );
     elseif ( event == "PLAYER_ENTERING_WORLD" ) then
          if ( TitanClan.Settings.DisplayB ) then TitanClan_CoreUtils( "Banner" ); end
          if ( IsInGuild() ) then TitanClan_CoreUtils( "buildRoster" ); end
--     elseif ( event == "VARIABLES_LOADED" ) then
--         print( "CVar Check" )
--          if ( GetCVar( "guildMemberNotify" ) == "0" ) then TitanClan_GuildNotifyConcent(); end
     elseif ( event == "CHAT_MSG_SYSTEM" ) then
          local matchOnline = "^.*%[(.*)%].*" .. string.sub( ERR_FRIEND_ONLINE_SS, 20 );
          local matchOffline = string.format( ERR_FRIEND_OFFLINE_S, "(.*)" );
          local matchAFKM = string.format( MARKED_AFK_MESSAGE, "(.*)" );
          local matchDND = string.format( MARKED_DND, "(.*)" );
          if ( string.match( arg1, matchOnline ) or string.match( arg1, matchOffline ) ) then
               local r1 = string.match( arg1, matchOnline );
               local r1 = string.match( arg1, matchOffline );
               if ( TitanClanRoster[r1] ) then GuildRoster(); end
          end
          if ( string.match( arg1, CLEARED_AFK ) or string.match( arg1, CLEARED_DND ) or string.match( arg1, MARKED_AFK ) or string.match( arg1, matchAFKM ) or string.match( arg1, matchDND ) ) then
               if ( IsInGuild() ) then GuildRoster(); end
          end
     elseif ( event == "GUILD_ROSTER_UPDATE" ) then
          if ( IsInGuild() ) then
               if ( not _G["TitanClanRanksBuilt"] ) then TitanClan_CoreUtils( "buildRanks" ) end
               if ( not _G["TitanClanRosterBuilt"] ) then TitanClan_CoreUtils( "buildRoster" ) end
               TitanClan_CoreUtils( "buildOnline" );
               TitanClan_CoreUtils( "sortData" );
          end
          TitanPanelButton_UpdateButton( LB["TITAN_CLAN_CORE_ID"] );
          TitanPanelButton_UpdateTooltip( self );
     end
     TitanClan_CoreUtils( "setIcon" );
end

-- **************************************************************************
-- NAME : TitanPanelClanButton_GetButtonText()
-- DESC : Build Button Text
-- **************************************************************************
function TitanPanelClanButton_GetButtonText()
     local buttonRichText, buttonRichLabel, numT, numO;
     if ( IsInGuild() ) then
          numT, numO = GetNumGuildMembers();
          numT = TitanClan_ColorUtils( "cText", "white", numT );
          numO = TitanClan_ColorUtils( "cText", "green", numO );
          buttonRichLabel = LB["TITAN_CLAN_BUTTON_LABEL"]:format( GetGuildInfo( "player" ) );
          buttonRichText = LB["TITAN_CLAN_BUTTON_TEXT"]:format( numO, numT );
     else
          buttonRichLabel = "";
          buttonRichText = LB["TITAN_CLAN_BUTTON_CLANLESS"];
     end
     return buttonRichLabel, buttonRichText;
end

-- **************************************************************************
-- NAME : TitanPanelClanButton_OnClick()
-- DESC : Toggles Friends Dialog
-- **************************************************************************
function TitanPanelClanButton_OnClick( self, button )
     if ( button == "LeftButton" ) then
          ToggleGuildFrame();
     else
          TitanPanelButton_OnClick( self, button );
     end
end

-- **************************************************************************
-- NAME : TitanClan_GuildNotifyConcent()
-- DESC : Need concent to change Guild Member Alert
-- **************************************************************************
function TitanClan_GuildNotifyConcent()
     StaticPopupDialogs["TITAN_CLAN_GUILD_NOTIFY_CONCENT"] = {
          text = LB["TITAN_CLAN_GUILD_NOTIFY_CONCENT"],
          button1 = ACCEPT,
          button2 = CANCEL,

          OnAccept = function( self )
               SetCVar( "guildMemberNotify", 1 );
          end,
          OnCancel = function( self )
               SetCVar( "guildMemberNotify", 0 );
          end,
          showAlertGear = 1,
          timeout = 0,
          whileDead = 1,
          hideOnEscape = 1

     };
     StaticPopup_Show( "TITAN_CLAN_GUILD_NOTIFY_CONCENT" );
end